Index: trunk/src/world_entities/particles/sprite_particles.cc
===================================================================
--- trunk/src/world_entities/particles/sprite_particles.cc	(revision 9869)
+++ trunk/src/world_entities/particles/sprite_particles.cc	(revision 9869)
@@ -0,0 +1,173 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GRAPHICS
+
+#include "sprite_particles.h"
+
+#include "util/loading/load_param.h"
+#include "util/loading/factory.h"
+#include "material.h"
+#include "state.h"
+#include "shell_command.h"
+
+#include "class_id_DEPRECATED.h"
+
+ObjectListDefinitionID(SpriteParticles, CL_SPRITE_PARTICLES);
+CREATE_FACTORY(SpriteParticles);
+
+SHELL_COMMAND(texture, SpriteParticles, setMaterialTexture)
+    ->defaultValues("maps/evil-flower.png");
+
+
+
+/**
+ *  standard constructor
+ * @param maxCount the Count of particles in the System
+ * @param type The Type of the SpriteParticles
+*/
+SpriteParticles::SpriteParticles (unsigned int maxCount)
+  : ParticleSystem(maxCount)
+{
+  this->init();
+}
+
+/**
+ * @brief creates a Particle System out of a XML-element
+ * @param root: the XML-element to load from
+ */
+SpriteParticles::SpriteParticles(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+}
+
+/**
+ *  standard deconstructor
+*/
+SpriteParticles::~SpriteParticles()
+{ }
+
+/**
+ * @brief initializes the SpriteParticles with default values
+*/
+void SpriteParticles::init()
+{
+  this->registerObject(this, SpriteParticles::_objectList);
+
+  this->material.setDiffuseMap("maps/radial-trans-noise.png");
+}
+
+
+/**
+ * loads Parameters from a TiXmlElement
+ * @param root the XML-element to load from.
+ */
+void SpriteParticles::loadParams(const TiXmlElement* root)
+{
+  ParticleSystem::loadParams(root);
+
+  LoadParam(root, "texture", this, SpriteParticles, setMaterialTexture);
+}
+
+/**
+ * @brief sets the Texutre that is placed onto the particles
+ * @param textureFile the Texture to load onto these SpriteParticles
+ */
+void SpriteParticles::setMaterialTexture(const std::string& textureFile)
+{
+  this->material.setDiffuseMap(textureFile);
+}
+
+/**
+ * @brief draws all the Particles of this System
+ *
+ * The Cases in this Function all do the same:
+ * Drawing all the particles with the appropriate Type.
+ * This is just the fastest Way to do this, but will most likely be changed in the future.
+ */
+void SpriteParticles::draw() const
+{
+
+  Particle* drawPart = particles;
+  this->material.select();
+
+  GLboolean checkLight = false;
+  glGetBooleanv(GL_LIGHTING, &checkLight);
+  glPushAttrib(GL_LIGHTING_BIT);
+  if (checkLight == GL_TRUE)
+    glDisable(GL_LIGHTING);
+
+  glDepthMask(GL_FALSE);
+  /*
+  glClearDepth(1.0);
+  glDepthFunc(GL_LEQUAL);
+  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+  glEnable(GL_BLEND);
+  glAlphaFunc(GL_GREATER,0.1);
+  glEnable(GL_ALPHA_TEST);
+  glEnable(GL_TEXTURE_2D);
+  glEnable(GL_CULL_FACE);
+  */
+  //glDepthMask(GL_FALSE);
+//glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
+
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_ENV_MODE, GL_MODULATE);
+
+
+  while (likely(drawPart != NULL))
+  {
+    glColor4fv(drawPart->color);
+    //! @todo implement a faster code for the look-at Camera algorithm.
+
+    const PNode* camera = State::getCameraNode();  //!< @todo MUST be different
+    Vector cameraPos = camera->getAbsCoor();
+    Vector cameraTargetPos = State::getCameraTargetNode()->getAbsCoor();
+    Vector view = cameraTargetPos - cameraPos;
+    Vector up = Vector(0, 1, 0);
+    up = camera->getAbsDir().apply(up);
+    Vector h = up.cross(view);
+    Vector v = h.cross(view);
+    h.normalize();
+    v.normalize();
+    v *= .5 * drawPart->radius;
+    h *= .5 * drawPart->radius;
+
+    glBegin(GL_TRIANGLE_STRIP);
+    glTexCoord2i(1, 1);
+    glVertex3f(drawPart->position.x - h.x - v.x,
+               drawPart->position.y - h.y - v.y,
+               drawPart->position.z - h.z - v.z);
+    glTexCoord2i(0, 1);
+    glVertex3f(drawPart->position.x - h.x + v.x,
+               drawPart->position.y - h.y + v.y,
+               drawPart->position.z - h.z + v.z);
+    glTexCoord2i(1, 0);
+    glVertex3f(drawPart->position.x + h.x - v.x,
+               drawPart->position.y + h.y - v.y,
+               drawPart->position.z + h.z - v.z);
+    glTexCoord2i(0, 0);
+    glVertex3f(drawPart->position.x + h.x + v.x,
+               drawPart->position.y + h.y + v.y,
+               drawPart->position.z + h.z + v.z);
+
+    glEnd();
+
+    drawPart = drawPart->next;
+  }
+  glDepthMask(GL_TRUE);
+  glPopAttrib();
+}
Index: trunk/src/world_entities/particles/sprite_particles.h
===================================================================
--- trunk/src/world_entities/particles/sprite_particles.h	(revision 9869)
+++ trunk/src/world_entities/particles/sprite_particles.h	(revision 9869)
@@ -0,0 +1,38 @@
+/*!
+ * @file sprite_particles.h
+
+*/
+
+#ifndef _SPRITE_PARTICLE_SYSTEM_H
+#define _SPRITE_PARTICLE_SYSTEM_H
+
+#include "particle_system.h"
+#include "material.h"
+
+//! A class to handle ParticleSystems
+class SpriteParticles : public ParticleSystem
+{
+  ObjectListDeclaration(SpriteParticles);
+
+public:
+  SpriteParticles(unsigned int maxCount = PARTICLE_DEFAULT_MAX_COUNT);
+  SpriteParticles(const TiXmlElement* root);
+  virtual ~SpriteParticles();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  void setMaterialTexture(const std::string& textureFile);
+
+  /** @returns the Material that lies on this particles */
+  inline const Material* getMaterial() const { return &this->material; };
+
+  virtual void draw() const;
+
+private:
+  void init();
+
+private:
+  Material          material;            //!< A Material for all the Particles.
+};
+
+#endif /* _SPRITE_PARTICLE_SYSTEM_H */
Index: trunk/src/world_entities/planet.cc
===================================================================
--- trunk/src/world_entities/planet.cc	(revision 9656)
+++ trunk/src/world_entities/planet.cc	(revision 9869)
@@ -30,9 +30,9 @@
 #include "primitive_model.h"
 
+#include "debug.h"
 
-
-
-CREATE_FACTORY(Planet, CL_PLANET);
-
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Planet, CL_PLANET);
+CREATE_FACTORY(Planet);
 
 
@@ -42,5 +42,5 @@
 Planet::Planet(const TiXmlElement* root)
 {
-  this->setClassID(CL_PLANET, "Planet");
+  this->registerObject(this, Planet::_objectList);
   this->toList(OM_GROUP_01);
 
Index: trunk/src/world_entities/planet.h
===================================================================
--- trunk/src/world_entities/planet.h	(revision 9656)
+++ trunk/src/world_entities/planet.h	(revision 9869)
@@ -16,4 +16,6 @@
 class Planet : public WorldEntity
 {
+  ObjectListDeclaration(Planet);
+
  public:
   Planet(const TiXmlElement* root);
Index: trunk/src/world_entities/playable.cc
===================================================================
--- trunk/src/world_entities/playable.cc	(revision 9656)
+++ trunk/src/world_entities/playable.cc	(revision 9869)
@@ -30,6 +30,6 @@
 #include "game_rules.h"
 
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "shared_network_data.h"
@@ -41,5 +41,5 @@
 SHELL_COMMAND_STATIC(orxoWeapon, Playable, Playable::addSomeWeapons_CHEAT)
   ->setAlias("orxoWeapon");
-
+ObjectListDefinition(Playable);
 
 Playable::Playable()
@@ -48,5 +48,5 @@
     playmode(Playable::Full3D)
 {
-  this->setClassID(CL_PLAYABLE, "Playable");
+  this->registerObject(this, Playable::_objectList);
   PRINTF(4)("PLAYABLE INIT\n");
 
@@ -109,11 +109,12 @@
 bool Playable::pickup(PowerUp* powerUp)
 {
-  if(powerUp->isA(CL_WEAPON_POWER_UP))
-  {
-    return dynamic_cast<WeaponPowerUp*>(powerUp)->process(&this->getWeaponManager());
-  }
-  else if(powerUp->isA(CL_PARAM_POWER_UP))
-  {
-    ParamPowerUp* ppu = dynamic_cast<ParamPowerUp*>(powerUp);
+  /// FIXME TOTALLY
+  if(powerUp->isA(WeaponPowerUp::staticClassID()))
+  {
+    return static_cast<WeaponPowerUp*>(powerUp)->process(&this->getWeaponManager());
+  }
+  else if(powerUp->isA(ParamPowerUp::staticClassID()))
+  {
+    ParamPowerUp* ppu = static_cast<ParamPowerUp*>(powerUp);
     switch(ppu->getType())
     {
@@ -213,9 +214,9 @@
     {
       PRINTF(2)("ADDING WEAPONS - you cheater\n");
-      playable->addWeapon(Weapon::createWeapon(CL_HYPERBLASTER));
-      playable->addWeapon(Weapon::createWeapon(CL_TURRET));
-      playable->addWeapon(Weapon::createWeapon(CL_AIMING_TURRET));
-      playable->addWeapon(Weapon::createWeapon(CL_CANNON));
-      playable->addWeapon(Weapon::createWeapon(CL_TARGETING_TURRET));
+      playable->addWeapon(Weapon::createWeapon("Hyperblaster"));
+      playable->addWeapon(Weapon::createWeapon("Turret"));
+      playable->addWeapon(Weapon::createWeapon("AimingTurret"));
+      playable->addWeapon(Weapon::createWeapon("Cannon"));
+      playable->addWeapon(Weapon::createWeapon("TargetingTurret"));
       PRINTF(2)("ADDING WEAPONS FINISHED\n");
     }
Index: trunk/src/world_entities/playable.h
===================================================================
--- trunk/src/world_entities/playable.h	(revision 9656)
+++ trunk/src/world_entities/playable.h	(revision 9869)
@@ -27,4 +27,5 @@
 class Playable : public WorldEntity, public Extendable
 {
+  ObjectListDeclaration(Playable);
 public:
   //! Defines the Playmode of an Entity.
Index: trunk/src/world_entities/player.cc
===================================================================
--- trunk/src/world_entities/player.cc	(revision 9656)
+++ trunk/src/world_entities/player.cc	(revision 9869)
@@ -19,6 +19,4 @@
 #include "event_handler.h"
 
-
-#include "class_list.h"
 #include "state.h"
 #include "util/hud.h"
@@ -26,5 +24,5 @@
 #include "debug.h"
 
-
+ObjectListDefinition(Player);
 /**
  * creates a new Player
@@ -33,5 +31,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_PLAYER, "Player");
+  this->registerObject(this, Player::_objectList);
 
   PRINTF(4)("PLAYER INIT\n");
@@ -94,8 +92,8 @@
 
 
- void Player::weaponConfigChanged()
- {
-   this->_hud.updateWeaponManager();
- }
+void Player::weaponConfigChanged()
+{
+  this->_hud.updateWeaponManager();
+}
 
 
@@ -103,17 +101,16 @@
 {
   /// FIXME this should be in the ObjectManager
-  const std::list<BaseObject*>* objectList = ClassList::getList(CL_PLAYABLE);
-  if (objectList != NULL)
+  for (ObjectList<Playable>::const_iterator node = Playable::objectList().begin();
+       node != Playable::objectList().end();
+       ++node)
   {
-    std::list<BaseObject*>::const_iterator node;
-    for (node = objectList->begin(); node != objectList->end(); node++)
-      if (this->playable != (*node) &&
-          (dynamic_cast<PNode*>(*node)->getAbsCoor() - this->playable->getAbsCoor()).len() < (dynamic_cast<Playable*>(*node)->getEnterRadius()))
-      {
+    if (this->playable != (*node) &&
+        ((*node)->getAbsCoor() - this->playable->getAbsCoor()).len() < ((*node)->getEnterRadius()))
+    {
 
-        this->setPlayable(dynamic_cast<Playable*>(*node));
+      this->setPlayable(*(node));
 
-        break;
-      }
+      break;
+    }
   }
 }
Index: trunk/src/world_entities/player.h
===================================================================
--- trunk/src/world_entities/player.h	(revision 9656)
+++ trunk/src/world_entities/player.h	(revision 9869)
@@ -23,4 +23,5 @@
 class Player : public EventListener
 {
+  ObjectListDeclaration(Player);
 
   public:
@@ -31,5 +32,5 @@
     bool              eject();
     inline Playable*  getPlayable() const  { return this->playable; };
-    
+
 
      inline Hud& hud() { return this->_hud; };
Index: trunk/src/world_entities/power_ups/laser_power_up.cc
===================================================================
--- trunk/src/world_entities/power_ups/laser_power_up.cc	(revision 9656)
+++ trunk/src/world_entities/power_ups/laser_power_up.cc	(revision 9869)
@@ -24,6 +24,7 @@
 
 
-
-CREATE_FACTORY(LaserPowerUp, CL_LASER_POWER_UP);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(LaserPowerUp, CL_LASER_POWER_UP);
+CREATE_FACTORY(LaserPowerUp);
 
 LaserPowerUp::LaserPowerUp () : PowerUp(0.0, 1.0, 0.0)
@@ -49,5 +50,5 @@
 void LaserPowerUp::init()
 {
-  this->setClassID(CL_LASER_POWER_UP, "LaserPowerUp");
+  this->registerObject(this, LaserPowerUp::_objectList);
   this->loadModel("models/guns/test_gun.obj", 2.0);
 
Index: trunk/src/world_entities/power_ups/laser_power_up.h
===================================================================
--- trunk/src/world_entities/power_ups/laser_power_up.h	(revision 9656)
+++ trunk/src/world_entities/power_ups/laser_power_up.h	(revision 9869)
@@ -13,4 +13,5 @@
 
 class LaserPowerUp : public PowerUp {
+  ObjectListDeclaration(LaserPowerUp);
 
  public:
@@ -22,5 +23,5 @@
 
 
-  virtual void LaserPowerUp::collidesWith(WorldEntity* entity, const Vector& location);
+  virtual void collidesWith(WorldEntity* entity, const Vector& location);
   virtual void tick(float dt);
   virtual void draw() const;
Index: trunk/src/world_entities/power_ups/param_power_up.cc
===================================================================
--- trunk/src/world_entities/power_ups/param_power_up.cc	(revision 9656)
+++ trunk/src/world_entities/power_ups/param_power_up.cc	(revision 9869)
@@ -27,6 +27,7 @@
 
 
-
-CREATE_FACTORY(ParamPowerUp, CL_PARAM_POWER_UP);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(ParamPowerUp, CL_PARAM_POWER_UP);
+CREATE_FACTORY(ParamPowerUp);
 
 const char* ParamPowerUp::paramTypes[] = {
@@ -58,5 +59,5 @@
 void ParamPowerUp::init()
 {
-  this->setClassID(CL_PARAM_POWER_UP, "ParamPowerUp");
+  this->registerObject(this, ParamPowerUp::_objectList);
   this->value = 0;
   this->max_value = 0;
Index: trunk/src/world_entities/power_ups/param_power_up.h
===================================================================
--- trunk/src/world_entities/power_ups/param_power_up.h	(revision 9656)
+++ trunk/src/world_entities/power_ups/param_power_up.h	(revision 9869)
@@ -20,4 +20,5 @@
 
 class ParamPowerUp : public PowerUp {
+  ObjectListDeclaration(ParamPowerUp);
 
 public:
Index: trunk/src/world_entities/power_ups/power_up.cc
===================================================================
--- trunk/src/world_entities/power_ups/power_up.cc	(revision 9656)
+++ trunk/src/world_entities/power_ups/power_up.cc	(revision 9869)
@@ -21,12 +21,14 @@
 #include "primitive_model.h"
 
-#include "util/loading/resource_manager.h"
+#include "sound/resource_sound_buffer.h"
 #include "util/loading/load_param.h"
 
+#include "debug.h"
 
+ObjectListDefinition(PowerUp);
 
 PowerUp::PowerUp(float r, float g, float b)
 {
-  this->setClassID(CL_POWER_UP, "PowerUp");
+  this->registerObject(this, PowerUp::_objectList);
 
   this->respawnType = RESPAWN_TIME;
@@ -45,6 +47,4 @@
 
   this->soundSource.setSourceNode(this);
-  this->pickupBuffer = NULL;
-  this->respawnBuffer = NULL;
 
   this->collider = NULL;
@@ -54,8 +54,4 @@
 {
   delete this->sphereMaterial;
-  if (this->pickupBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->pickupBuffer);
-  if (this->respawnBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->respawnBuffer);
 }
 
@@ -77,42 +73,16 @@
 void PowerUp::loadPickupSound(const std::string& pickupSound)
 {
-  if (this->pickupBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->pickupBuffer);
-
-  else if (!pickupSound.empty())
-  {
-    this->pickupBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load(pickupSound, WAV);
-    if (this->pickupBuffer != NULL)
-    {
-      PRINTF(4)("Loaded sound %s to Pickup: %s.\n", pickupSound.c_str(), this->getCName());
-    }
-    else
-    {
-      PRINTF(2)("Failed to load sound %s to pickup %s.\n.", pickupSound.c_str(), this->getCName());
-    }
-  }
+  if (!pickupSound.empty())
+    this->pickupBuffer = OrxSound::ResourceSoundBuffer(pickupSound);
   else
-    this->pickupBuffer = NULL;
+    this->pickupBuffer = OrxSound::SoundBuffer();
 }
 
 void PowerUp::loadRespawnSound(const std::string& respawnSound)
 {
-  if (this->respawnBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->respawnBuffer);
-
-  else if (!respawnSound.empty())
-  {
-    this->respawnBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load(respawnSound, WAV);
-    if (this->respawnBuffer != NULL)
-    {
-      PRINTF(4)("Loaded sound %s to Pickup: %s.\n", respawnSound.c_str(), this->getCName());
-    }
-    else
-    {
-      PRINTF(2)("Failed to load sound %s to respawn %s.\n.", respawnSound.c_str(), this->getCName());
-    }
-  }
+  if (!respawnSound.empty())
+    this->respawnBuffer = OrxSound::ResourceSoundBuffer(respawnSound);
   else
-    this->respawnBuffer = NULL;
+    this->respawnBuffer = OrxSound::SoundBuffer();
 }
 
@@ -120,10 +90,10 @@
 void PowerUp::collidesWith (WorldEntity* entity, const Vector& location)
 {
-  if(this->collider != entity && entity->isA(CL_EXTENDABLE))
+  if(this->collider != entity && entity->isA(Extendable::staticClassID()))
   {
     this->collider = entity;
     if(dynamic_cast<Extendable*>(entity)->pickup(this))
     {
-      if(pickupBuffer != NULL)
+      if(pickupBuffer.loaded())
         this->soundSource.play(this->pickupBuffer);
 
@@ -154,5 +124,5 @@
       this->toList(OM_COMMON);
       this->collider = NULL;
-      if (likely(this->respawnBuffer != NULL))
+      if (likely(this->respawnBuffer.loaded()))
         this->soundSource.play(this->respawnBuffer);
 
Index: trunk/src/world_entities/power_ups/power_up.h
===================================================================
--- trunk/src/world_entities/power_ups/power_up.h	(revision 9656)
+++ trunk/src/world_entities/power_ups/power_up.h	(revision 9869)
@@ -21,4 +21,5 @@
 
 class PowerUp : public WorldEntity {
+  ObjectListDeclaration(PowerUp);
 
 public:
@@ -43,6 +44,6 @@
 private:
   OrxSound::SoundSource  soundSource;
-  OrxSound::SoundBuffer* pickupBuffer;
-  OrxSound::SoundBuffer* respawnBuffer;
+  OrxSound::SoundBuffer  pickupBuffer;
+  OrxSound::SoundBuffer  respawnBuffer;
   Material*              sphereMaterial;
   PowerUpRespawn         respawnType;
Index: trunk/src/world_entities/power_ups/turret_power_up.cc
===================================================================
--- trunk/src/world_entities/power_ups/turret_power_up.cc	(revision 9656)
+++ trunk/src/world_entities/power_ups/turret_power_up.cc	(revision 9869)
@@ -24,6 +24,7 @@
 
 
-
-CREATE_FACTORY(TurretPowerUp, CL_TURRET_POWER_UP);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(TurretPowerUp, CL_TURRET_POWER_UP);
+CREATE_FACTORY(TurretPowerUp);
 
 TurretPowerUp::TurretPowerUp(const TiXmlElement* root) : PowerUp(0.0, 1.0, 0.0)
@@ -45,5 +46,5 @@
 void TurretPowerUp::init()
 {
-  this->setClassID(CL_TURRET_POWER_UP, "TurretPowerUp");
+  this->registerObject(this, TurretPowerUp::_objectList);
   this->loadModel("models/guns/turret1.obj", 2.0);
 
Index: trunk/src/world_entities/power_ups/turret_power_up.h
===================================================================
--- trunk/src/world_entities/power_ups/turret_power_up.h	(revision 9656)
+++ trunk/src/world_entities/power_ups/turret_power_up.h	(revision 9869)
@@ -13,4 +13,5 @@
 
 class TurretPowerUp : public PowerUp {
+  ObjectListDeclaration(TurretPowerUp);
 
  public:
@@ -20,5 +21,5 @@
   virtual void loadParams(const TiXmlElement* root);
 
-  virtual void TurretPowerUp::collidesWith(WorldEntity* entity, const Vector& location);
+  virtual void collidesWith(WorldEntity* entity, const Vector& location);
   virtual void tick(float dt);
   virtual void draw() const;
Index: trunk/src/world_entities/power_ups/weapon_power_up.cc
===================================================================
--- trunk/src/world_entities/power_ups/weapon_power_up.cc	(revision 9656)
+++ trunk/src/world_entities/power_ups/weapon_power_up.cc	(revision 9869)
@@ -25,8 +25,9 @@
 #include "util/loading/factory.h"
 #include "util/loading/load_param.h"
+#include "debug.h"
 
-
-
-CREATE_FACTORY(WeaponPowerUp, CL_WEAPON_POWER_UP);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(WeaponPowerUp, CL_WEAPON_POWER_UP);
+CREATE_FACTORY(WeaponPowerUp);
 
 WeaponPowerUp::WeaponPowerUp(const TiXmlElement* root) : PowerUp(1.0, 1.0, 0.0)
@@ -45,5 +46,5 @@
 void WeaponPowerUp::init()
 {
-  this->setClassID(CL_WEAPON_POWER_UP, "WeaponPowerUp");
+  this->registerObject(this, WeaponPowerUp::_objectList);
   this->loadPickupSound("sound/powerups/whats this2.wav");
 
@@ -87,5 +88,5 @@
 {
   this->weapon = dynamic_cast<Weapon*>((weaponXML == NULL)
-      ? Factory::fabricate(static_cast<ClassID>(this->weapon->getLeafClassID()))
+      ? Factory::fabricate((this->weapon->getClassID()))
       : Factory::fabricate((const TiXmlElement*)this->getXmlElem()->FirstChildElement("weapon")));
   this->model = this->weapon->getModel(0);
Index: trunk/src/world_entities/power_ups/weapon_power_up.h
===================================================================
--- trunk/src/world_entities/power_ups/weapon_power_up.h	(revision 9656)
+++ trunk/src/world_entities/power_ups/weapon_power_up.h	(revision 9869)
@@ -14,5 +14,5 @@
 
 class WeaponPowerUp : public PowerUp {
-
+ObjectListDeclaration(WeaponPowerUp);
 public:
   WeaponPowerUp(const TiXmlElement* root = NULL);
Index: trunk/src/world_entities/projectiles/bomb.cc
===================================================================
--- trunk/src/world_entities/projectiles/bomb.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/bomb.cc	(revision 9869)
@@ -20,10 +20,12 @@
 #include "primitive_model.h"
 
-#include "dot_emitter.h"
-#include "particle_system.h"
+#include "particles/dot_emitter.h"
+#include "particles/particle_system.h"
 
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(Bomb, CL_BOMB);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Bomb, CL_BOMB);
+CREATE_FAST_FACTORY_STATIC(Bomb);
 
 /**
@@ -67,5 +69,5 @@
 void Bomb::init()
 {
-  this->setClassID(CL_BOMB, "Bomb");
+  this->registerObject(this, Bomb::_objectList);
 
 
@@ -173,4 +175,5 @@
 }
 
+
 void Bomb::deactivate()
 {
@@ -182,10 +185,11 @@
 void Bomb::detonate(float size)
 {
-  ObjectManager::EntityList detonationList;
-  ObjectManager::distanceFromObject(detonationList, *this, size, CL_NPC);
+  /// FIXME
+/*  ObjectManager::EntityList detonationList;
+  ObjectManager::distanceFromObject(detonationList, *this, size, NPC::objectList());
     while( !detonationList.empty() )
     {
       detonationList.front()->collidesWith(this, Vector(0,0,0));
       detonationList.pop_front();
-    }
+    }*/
 }
Index: trunk/src/world_entities/projectiles/bomb.h
===================================================================
--- trunk/src/world_entities/projectiles/bomb.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/bomb.h	(revision 9869)
@@ -17,5 +17,5 @@
 class Bomb : public Projectile
 {
-
+  ObjectListDeclaration(Bomb);
  public:
   Bomb(const TiXmlElement* root = NULL);
Index: trunk/src/world_entities/projectiles/boomerang_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/boomerang_projectile.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/boomerang_projectile.cc	(revision 9869)
@@ -20,12 +20,13 @@
 
 #include "state.h"
-#include "class_list.h"
-
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(BoomerangProjectile, CL_BOOMERANG_PROJECTILE);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(BoomerangProjectile, CL_BOOMERANG_PROJECTILE);
+CREATE_FAST_FACTORY_STATIC(BoomerangProjectile);
 
 /**
@@ -34,5 +35,5 @@
 BoomerangProjectile::BoomerangProjectile () : Projectile()
 {
-  this->setClassID(CL_BOOMERANG_PROJECTILE, "BoomerangProjectile");
+  this->registerObject(this, BoomerangProjectile::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", 2.0);
@@ -60,13 +61,13 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (BoomerangProjectile::trailParticles != NULL && ClassList::getList(CL_BOOMERANG_PROJECTILE)->size() <= 1)
-  {
-    if (ClassList::exists(BoomerangProjectile::trailParticles, CL_PARTICLE_SYSTEM))
+  if (BoomerangProjectile::trailParticles != NULL && BoomerangProjectile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(BoomerangProjectile::trailParticles))
       delete BoomerangProjectile::trailParticles;
     BoomerangProjectile::trailParticles = NULL;
   }
-  if (BoomerangProjectile::explosionParticles != NULL && ClassList::getList(CL_BOOMERANG_PROJECTILE)->size() <= 1)
-  {
-    if (ClassList::exists(BoomerangProjectile::explosionParticles, CL_PARTICLE_SYSTEM))
+  if (BoomerangProjectile::explosionParticles != NULL && BoomerangProjectile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(BoomerangProjectile::explosionParticles))
       delete BoomerangProjectile::explosionParticles;
     BoomerangProjectile::explosionParticles = NULL;
Index: trunk/src/world_entities/projectiles/boomerang_projectile.h
===================================================================
--- trunk/src/world_entities/projectiles/boomerang_projectile.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/boomerang_projectile.h	(revision 9869)
@@ -17,4 +17,5 @@
 class BoomerangProjectile : public Projectile
 {
+  ObjectListDeclaration(BoomerangProjectile);
   public:
     BoomerangProjectile ();
Index: trunk/src/world_entities/projectiles/guided_missile.cc
===================================================================
--- trunk/src/world_entities/projectiles/guided_missile.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/guided_missile.cc	(revision 9869)
@@ -19,12 +19,13 @@
 
 #include "state.h"
-#include "class_list.h"
-
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(GuidedMissile, CL_GUIDED_MISSILE);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(GuidedMissile, CL_GUIDED_MISSILE);
+CREATE_FAST_FACTORY_STATIC(GuidedMissile);
 
 /**
@@ -33,5 +34,5 @@
 GuidedMissile::GuidedMissile () : Projectile()
 {
-  this->setClassID(CL_GUIDED_MISSILE, "GuidedMissile");
+  this->registerObject(this, GuidedMissile::_objectList);
 
   this->loadModel("models/projectiles/orx-rocket.obj", 2.0);
@@ -59,13 +60,13 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (GuidedMissile::trailParticles != NULL && ClassList::getList(CL_GUIDED_MISSILE)->size() <= 1)
-  {
-    if (ClassList::exists(GuidedMissile::trailParticles, CL_PARTICLE_SYSTEM))
+  if (GuidedMissile::trailParticles != NULL && GuidedMissile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(GuidedMissile::trailParticles))
       delete GuidedMissile::trailParticles;
     GuidedMissile::trailParticles = NULL;
   }
-  if (GuidedMissile::explosionParticles != NULL && ClassList::getList(CL_GUIDED_MISSILE)->size() <= 1)
-  {
-    if (ClassList::exists(GuidedMissile::explosionParticles, CL_PARTICLE_SYSTEM))
+  if (GuidedMissile::explosionParticles != NULL && GuidedMissile::objectList().size() <= 1)
+  {
+    if (ParticleSystem::objectList().exists(GuidedMissile::explosionParticles))
       delete GuidedMissile::explosionParticles;
     GuidedMissile::explosionParticles = NULL;
Index: trunk/src/world_entities/projectiles/guided_missile.h
===================================================================
--- trunk/src/world_entities/projectiles/guided_missile.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/guided_missile.h	(revision 9869)
@@ -16,4 +16,5 @@
 class GuidedMissile : public Projectile
 {
+  ObjectListDeclaration(GuidedMissile);
   public:
     GuidedMissile ();
Index: trunk/src/world_entities/projectiles/hyperblast.cc
===================================================================
--- trunk/src/world_entities/projectiles/hyperblast.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/hyperblast.cc	(revision 9869)
@@ -19,12 +19,14 @@
 
 #include "state.h"
-#include "class_list.h"
 
-#include "box_emitter.h"
-#include "spark_particles.h"
+#include "particles/box_emitter.h"
+#include "particles/spark_particles.h"
 
 #include "debug.h"
 
-CREATE_FAST_FACTORY_STATIC(Hyperblast, CL_HYPERBLAST);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(Hyperblast, CL_HYPERBLAST);
+CREATE_FAST_FACTORY_STATIC(Hyperblast);
+
 
 /**
@@ -33,5 +35,5 @@
 Hyperblast::Hyperblast () : Projectile()
 {
-  this->setClassID(CL_HYPERBLAST, "Hyperblast");
+  this->registerObject(this, Hyperblast::_objectList);
 
   this->loadModel("models/projectiles/hyperblast.obj", 5);
@@ -55,5 +57,5 @@
 {
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Hyperblast::explosionParticles != NULL && ClassList::getList(CL_HYPERBLAST)->size() <= 1)
+  if (Hyperblast::explosionParticles != NULL && Hyperblast::objectList().size() <= 1)
   {
     Hyperblast::explosionParticles = NULL;
Index: trunk/src/world_entities/projectiles/hyperblast.h
===================================================================
--- trunk/src/world_entities/projectiles/hyperblast.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/hyperblast.h	(revision 9869)
@@ -17,4 +17,5 @@
 class Hyperblast : public Projectile
 {
+  ObjectListDeclaration(Hyperblast);
   public:
     Hyperblast ();
Index: trunk/src/world_entities/projectiles/laser.cc
===================================================================
--- trunk/src/world_entities/projectiles/laser.cc	(revision 9656)
+++ trunk/src/world_entities/projectiles/laser.cc	(revision 9869)
@@ -19,9 +19,8 @@
 
 #include "state.h"
-#include "class_list.h"
 #include "model.h"
 
-#include "dot_emitter.h"
-#include "sprite_particles.h"
+#include "particles/dot_emitter.h"
+#include "particles/sprite_particles.h"
 
 #include <cassert>
@@ -29,6 +28,7 @@
 
 
-
-CREATE_FAST_FACTORY_STATIC(Laser, CL_LASER);
+#include "class_id_DEPRECATED.h"
+ObjectListDefinition(Laser);
+CREATE_FAST_FACTORY_STATIC(Laser);
 
 /**
@@ -37,5 +37,5 @@
 Laser::Laser () : Projectile()
 {
-  this->setClassID(CL_LASER, "Laser");
+  this->registerObject(this, Laser::_objectList);
 
   this->loadModel("models/projectiles/laser.obj");
@@ -61,5 +61,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Laser::explosionParticles != NULL && ClassList::getList(CL_LASER)->size() <= 1)
+  if (Laser::explosionParticles != NULL && Laser::objectList().size() <= 1)
   {
     //if (ClassList::exists(Laser::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/projectiles/laser.h
===================================================================
--- trunk/src/world_entities/projectiles/laser.h	(revision 9656)
+++ trunk/src/world_entities/projectiles/laser.h	(revision 9869)
@@ -17,4 +17,5 @@
 class Laser : public Projectile
 {
+  ObjectListDeclaration(Laser);
   public:
     Laser ();
